"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enumerator_1 = require("./enumerator");
class MappedEnumerator extends enumerator_1.AbstractDelegatingEnumerator {
    constructor(delegate, mapper) {
        super(delegate);
        this.mapper = mapper;
        this.current = undefined;
        this.hasCurrent = false;
        this.add(delegate);
    }
    move(req) {
        const enumerator = this.delegate;
        const hasCurrent = enumerator.move(req);
        this.hasCurrent = hasCurrent;
        if (hasCurrent) {
            this.current = this.mapper(enumerator.current);
        }
        return hasCurrent;
    }
}
class MappedEnumerable {
    constructor(delegate, mapper) {
        this.delegate = delegate;
        this.mapper = mapper;
    }
    enumerate() {
        return new MappedEnumerator(this.delegate.enumerate(), this.mapper);
    }
}
exports.map = (mapper) => (enumerable) => new MappedEnumerable(enumerable, mapper);
//# sourceMappingURL=map.js.map