import { AbstractDelegatingEnumerator } from "./enumerator";
class MappedEnumerator extends AbstractDelegatingEnumerator {
    constructor(delegate, mapper) {
        super(delegate);
        this.mapper = mapper;
        this.current = undefined;
        this.hasCurrent = false;
        this.add(delegate);
    }
    move(req) {
        const enumerator = this.delegate;
        const hasCurrent = enumerator.move(req);
        this.hasCurrent = hasCurrent;
        if (hasCurrent) {
            this.current = this.mapper(enumerator.current);
        }
        return hasCurrent;
    }
}
class MappedEnumerable {
    constructor(delegate, mapper) {
        this.delegate = delegate;
        this.mapper = mapper;
    }
    enumerate() {
        return new MappedEnumerator(this.delegate.enumerate(), this.mapper);
    }
}
export const map = (mapper) => (enumerable) => new MappedEnumerable(enumerable, mapper);
//# sourceMappingURL=map.js.map